#------------------------------------------------------------------------------
# <auto-generated>
#     This file was auto generated.
#
#     Changes to this file may cause incorrect behavior and will be lost if
#     the code is regenerated.
# </auto-generated>
#------------------------------------------------------------------------------
import typing
from abc import abstractmethod, ABCMeta
from Oasys.AdSec.Materials.StressStrainCurves import ITensionCompressionCurve


# noinspection PyPep8Naming
class IMaterial(metaclass=ABCMeta):
    """A material for use in AdSec.
    
    See "~/articles/glossary.html#materialmaterial""Glossary/see
    """

    @property
    def Serviceability(self) -> ITensionCompressionCurve:
        """
        """
        pass

    @property
    def Strength(self) -> ITensionCompressionCurve:
        """
        """
        pass


# noinspection PyPep8Naming
class IConcrete(IMaterial, metaclass=ABCMeta):
    """A concrete material.
    """

    @staticmethod
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve) -> IConcrete:
        """Creates a new concrete material from its strength (ULS) and
        serviceability (SLS) stress-strain relationship.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :return: A new concrete material with the given sterss-strain relationships.
        :rtype: IConcrete
        """
        pass


# noinspection PyPep8Naming
class IFrp(IMaterial, metaclass=ABCMeta):
    """A fibre-reinforced polymer (FRP) material.
    """

    @staticmethod
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve) -> IFrp:
        """Creates a new FRP material from its strength (ULS) and
        serviceability (SLS) stress-strain relationship.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :return: A new FRP material with the given sterss-strain relationships.
        :rtype: IFrp
        """
        pass


# noinspection PyPep8Naming
class IReinforcement(IMaterial, metaclass=ABCMeta):
    """A reinforcement material.
    """

    @staticmethod
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve) -> IReinforcement:
        """Creates a new reinforcement material from its strength (ULS) and
        serviceability (SLS) stress-strain relationship.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :return: A new reinforcement material with the given sterss-strain relationships.
        :rtype: IReinforcement
        """
        pass


# noinspection PyPep8Naming
class ISteel(IMaterial, metaclass=ABCMeta):
    """A steel material.
    """

    @staticmethod
    def Create(strength: ITensionCompressionCurve, serviceability: ITensionCompressionCurve) -> ISteel:
        """Creates a new steel material from its strength (ULS) and
        serviceability (SLS) stress-strain relationship.

        :param strength: The material's stress-strain relationship for strength (ULS) analysis.
        :type strength: ITensionCompressionCurve
        :param serviceability: The material's stress-strain relationship for serviceability (SLS) analysis.
        :type serviceability: ITensionCompressionCurve
        :return: A new steel material with the given sterss-strain relationships.
        :rtype: ISteel
        """
        pass
